class FullVoter < Voter
  validates_presence_of :email, :password

  def initialize(params={})
    super
    create_password
  end
  
  def create_password
    token_generator = UniqueTokenGenerator.new( 16 )
    until password and not password.empty? \
          and Voter.find(:all, :conditions => [ "password = ?", password ]).empty?
      self.password = token_generator.token
    end
  end
  
  protected
  def validate
    # E-mail regex, moderate complexity
    # Stolen from http://www.regular-expressions.info/email.html
    errors.add(:email, "is not valid") unless email  =~
                  /^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i
  end
end
